#
# This script was written by Michel Arboi <arboi@alussinan.org>
#
# GPL...
#
# SMTP is defined by RFC 821. Messages are defined by RFC 822
#
# Script audit and contributions from Carmichael Security <http://www.carmichaelsecurity.com>
#      Erik Anderson <eanders@carmichaelsecurity.com>
#      Added links to the Bugtraq message archive

# You can get the EICAR test string at http://www.eicar.org/anti_virus_test_file.htm
#
# References :
# From: "3APA3A" <3APA3A@SECURITY.NNOV.RU>
# Affiliation: http://www.security.nnov.ru
# To: BUGTRAQ@SECURITYFOCUS.COM
# Subject: SECURITY.NNOV: Bypassing content filtering software
#
# Date:  Mon, 3 Jun 2002 16:19:58 -0400 (EDT)
# From: "David F. Skoll" <dfs@roaringpenguin.com>
# To: bugtraq@securityfocus.com
# Subject: MIME::Tools Perl module and virus scanners
#
# Date:  Fri, 22 Mar 2002 13:24:42 +0300
# From: "3APA3A" <3APA3A@SECURITY.NNOV.RU>
# To: BUGTRAQ@SECURITYFOCUS.COM
# CC: vuln-dev@SECURITYFOCUS.COM
# Subject: One more way to bypass NAV
# 


if(description)
{
 script_id(11034);
 script_version ("$Revision: 1.18 $");
 name["english"] = "SMTP antivirus filter";
 script_name(english:name["english"]);
 
 desc["english"] = "
Nessus sent several emails containing the EICAR
test strings in them to the postmaster of
the remote SMTP server.

The EICAR test string is a fake virus which
triggers anti-viruses, in order to make sure
they run.

Nessus attempted to e-mail this string five times,
with different codings each time, in order to attempt
to fool the remote anti-virus (if any).


If there is an antivirus filter, these messages should
all be blocked.

*** To determine if the remote host is vulnerable, see
*** if any mail arrived to the postmaster of this host

Solution: Install an antivirus / upgrade it

Reference : http://online.securityfocus.com/archive/1/256619
Reference : http://online.securityfocus.com/archive/1/44301
Reference : http://online.securityfocus.com/links/188

Risk factor : Low";

 script_description(english:desc["english"]);
 
 summary["english"] = "Test a SMTP antivirus filter";
 script_summary(english:summary["english"]);
 
 script_category(ACT_ATTACK);
 
 script_copyright(english:"This script is Copyright (C) 2002 Michel Arboi");
 family["english"] = "Firewalls";
 script_family(english:family["english"]);

 script_dependencie("find_service.nes", "smtp_settings.nasl", "smtp_relay.nasl");
 script_require_ports("Services/smtp", 25);
 script_exclude_keys("SMTP/spam");

 #
 exit(0);
}

#
# The script code starts here
#



include("smtp_func.inc");

kb = get_kb_item("SMTP/spam");
if(kb)exit(0);

doublequote=raw_string(0x22);
closebracket=raw_string(0x7D);


#

n_sent = 0;

fromaddr = smtp_from_header();
toaddr = smtp_to_header();

port = get_kb_item("Services/smtp");
if (!port) port = 25;

if(!get_port_state(port))exit(0);

s = open_sock_tcp(port);
if (!s) exit(0);

buffer = smtp_recv_banner(socket:s);

send(socket: s, data: string("HELO nessus\r\n"));
buff = recv_line(socket:s, length:2048);

# MIME attachment

header = string("From: ", fromaddr, "\r\nTo: ", toaddr, "\r\n",
	"Organization: Nessus kabale\r\nMIME-Version: 1.0\r\n");


msg = raw_string(
0x53, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x3a, 
0x20, 0x4e, 0x65, 0x73, 0x73, 0x75, 0x73, 0x20, 
0x61, 0x6e, 0x74, 0x69, 0x76, 0x69, 0x72, 0x75, 
0x73, 0x20, 0x74, 0x65, 0x73, 0x74, 0x20, 0x31, 
0x3a, 0x20, 0x62, 0x61, 0x73, 0x65, 0x36, 0x34, 
0x20, 0x61, 0x74, 0x74, 0x61, 0x63, 0x68, 0x6d, 
0x65, 0x6e, 0x74, 0x0d, 0x0a, 0x43, 0x6f, 0x6e, 
0x74, 0x65, 0x6e, 0x74, 0x2d, 0x54, 0x79, 0x70, 
0x65, 0x3a, 0x20, 0x6d, 0x75, 0x6c, 0x74, 0x69, 
0x70, 0x61, 0x72, 0x74, 0x2f, 0x6d, 0x69, 0x78, 
0x65, 0x64, 0x3b, 0x20, 0x62, 0x6f, 0x75, 0x6e, 
0x64, 0x61, 0x72, 0x79, 0x3d, 0x22, 0x3d, 0x2d, 
0x3d, 0x2d, 0x3d, 0x22, 0x0d, 0x0a, 0x4c, 0x69, 
0x6e, 0x65, 0x73, 0x3a, 0x20, 0x31, 0x33, 0x0d, 
0x0a, 0x0d, 0x0a, 0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 
0x2d, 0x3d, 0x2d, 0x3d, 0x0d, 0x0a, 0x0d, 0x0a, 
0x49, 0x66, 0x20, 0x79, 0x6f, 0x75, 0x20, 0x63, 
0x61, 0x6e, 0x20, 0x72, 0x65, 0x61, 0x64, 0x20, 
0x6f, 0x72, 0x20, 0x65, 0x78, 0x65, 0x63, 0x75, 
0x74, 0x65, 0x20, 0x74, 0x68, 0x65, 0x20, 0x61, 
0x74, 0x74, 0x61, 0x63, 0x68, 0x6d, 0x65, 0x6e, 
0x74, 0x2c, 0x20, 0x74, 0x68, 0x69, 0x73, 0x20, 
0x6d, 0x65, 0x61, 0x6e, 0x73, 0x20, 0x74, 0x68, 
0x61, 0x74, 0x20, 0x79, 0x6f, 0x75, 0x20, 0x64, 
0x6f, 0x20, 0x6e, 0x6f, 0x74, 0x0d, 0x0a, 0x68, 
0x61, 0x76, 0x65, 0x20, 0x61, 0x6e, 0x20, 0x61, 
0x6e, 0x74, 0x69, 0x76, 0x69, 0x72, 0x75, 0x73, 
0x2c, 0x20, 0x6f, 0x72, 0x20, 0x74, 0x68, 0x61, 
0x74, 0x20, 0x69, 0x74, 0x20, 0x77, 0x61, 0x73, 
0x20, 0x64, 0x69, 0x73, 0x61, 0x62, 0x6c, 0x65, 
0x64, 0x2e, 0x0d, 0x0a, 0x0d, 0x0a, 0x2d, 0x2d, 
0x3d, 0x2d, 0x3d, 0x2d, 0x3d, 0x0d, 0x0a, 0x43, 
0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x74, 0x2d, 0x54, 
0x79, 0x70, 0x65, 0x3a, 0x20, 0x61, 0x70, 0x70, 
0x6c, 0x69, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 
0x2f, 0x6f, 0x63, 0x74, 0x65, 0x74, 0x2d, 0x73, 
0x74, 0x72, 0x65, 0x61, 0x6d, 0x0d, 0x0a, 0x43, 
0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x74, 0x2d, 0x44, 
0x69, 0x73, 0x70, 0x6f, 0x73, 0x69, 0x74, 0x69, 
0x6f, 0x6e, 0x3a, 0x20, 0x61, 0x74, 0x74, 0x61, 
0x63, 0x68, 0x6d, 0x65, 0x6e, 0x74, 0x3b, 0x20, 
0x66, 0x69, 0x6c, 0x65, 0x6e, 0x61, 0x6d, 0x65, 
0x3d, 0x65, 0x69, 0x63, 0x61, 0x72, 0x2e, 0x63, 
0x6f, 0x6d, 0x0d, 0x0a, 0x43, 0x6f, 0x6e, 0x74, 
0x65, 0x6e, 0x74, 0x2d, 0x44, 0x65, 0x73, 0x63, 
0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x3a, 
0x20, 0x45, 0x49, 0x43, 0x41, 0x52, 0x20, 0x74, 
0x65, 0x73, 0x74, 0x20, 0x66, 0x69, 0x6c, 0x65, 
0x0d, 0x0a, 0x0d, 0x0a, 0x58, 0x35, 0x4f, 0x21, 
0x50, 0x25, 0x40, 0x41, 0x50, 0x5b, 0x34, 0x5c, 
0x50, 0x5a, 0x58, 0x35, 0x34, 0x28, 0x50, 0x5e, 
0x29, 0x37, 0x43, 0x43, 0x29, 0x37, 0x7d, 0x24, 
0x45, 0x49, 0x43, 0x41, 0x52, 0x2d, 0x53, 0x54, 
0x41, 0x4e, 0x44, 0x41, 0x52, 0x44, 0x2d, 0x41, 
0x4e, 0x54, 0x49, 0x56, 0x49, 0x52, 0x55, 0x53, 
0x2d, 0x54, 0x45, 0x53, 0x54, 0x2d, 0x46, 0x49, 
0x4c, 0x45, 0x21, 0x24, 0x48, 0x2b, 0x48, 0x2a, 
0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 
0x3d, 0x2d, 0x2d, 0x0d, 0x0a, 0x0d, 0x0a);


n=smtp_send_socket(socket:s, from: fromaddr, to: toaddr, body: string(header,msg));
n_sent=n_sent+n;


# uuencode

msg = raw_string(
0x53, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x3a, 
0x20, 0x4e, 0x65, 0x73, 0x73, 0x75, 0x73, 0x20, 
0x61, 0x6e, 0x74, 0x69, 0x76, 0x69, 0x72, 0x75, 
0x73, 0x20, 0x74, 0x65, 0x73, 0x74, 0x20, 0x32, 
0x3a, 0x20, 0x75, 0x75, 0x65, 0x6e, 0x63, 0x6f, 
0x64, 0x65, 0x64, 0x20, 0x61, 0x74, 0x74, 0x61, 
0x63, 0x68, 0x6d, 0x65, 0x6e, 0x74, 0x0d, 0x0a, 
0x4c, 0x69, 0x6e, 0x65, 0x73, 0x3a, 0x20, 0x39, 
0x0d, 0x0a, 0x0d, 0x0a, 0x49, 0x66, 0x20, 0x79, 
0x6f, 0x75, 0x20, 0x63, 0x61, 0x6e, 0x20, 0x72, 
0x65, 0x61, 0x64, 0x20, 0x6f, 0x72, 0x20, 0x65, 
0x78, 0x65, 0x63, 0x75, 0x74, 0x65, 0x20, 0x74, 
0x68, 0x65, 0x20, 0x61, 0x74, 0x74, 0x61, 0x63, 
0x68, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x2c, 0x20, 
0x79, 0x6f, 0x75, 0x20, 0x6e, 0x65, 0x65, 0x64, 
0x20, 0x74, 0x6f, 0x20, 0x69, 0x6e, 0x73, 0x74, 
0x61, 0x6c, 0x6c, 0x20, 0x61, 0x6e, 0x0d, 0x0a, 
0x61, 0x6e, 0x74, 0x69, 0x76, 0x69, 0x72, 0x75, 
0x73, 0x20, 0x6f, 0x72, 0x20, 0x66, 0x69, 0x78, 
0x20, 0x79, 0x6f, 0x75, 0x72, 0x20, 0x63, 0x75, 
0x72, 0x72, 0x65, 0x6e, 0x74, 0x20, 0x6f, 0x6e, 
0x65, 0x2e, 0x0d, 0x0a, 0x0d, 0x0a, 0x62, 0x65, 
0x67, 0x69, 0x6e, 0x20, 0x36, 0x36, 0x34, 0x20, 
0x65, 0x69, 0x63, 0x61, 0x72, 0x2e, 0x63, 0x6f, 
0x6d, 0x0d, 0x0a, 0x4d, 0x36, 0x23, 0x35, 0x2f, 
0x28, 0x35, 0x60, 0x45, 0x30, 0x24, 0x25, 0x30, 
0x36, 0x53, 0x31, 0x3c, 0x34, 0x25, 0x49, 0x38, 
0x2d, 0x33, 0x30, 0x48, 0x34, 0x25, 0x58, 0x49, 
0x2d, 0x54, 0x2d, 0x23, 0x2a, 0x33, 0x3d, 0x5d, 
0x29, 0x24, 0x35, 0x29, 0x30, 0x54, 0x25, 0x32, 
0x2b, 0x35, 0x2d, 0x34, 0x30, 0x34, 0x59, 0x24, 
0x30, 0x35, 0x29, 0x24, 0x2b, 0x34, 0x25, 0x2e, 
0x0d, 0x0a, 0x37, 0x35, 0x24, 0x45, 0x36, 0x32, 
0x35, 0x29, 0x35, 0x34, 0x52, 0x55, 0x34, 0x31, 
0x35, 0x2d, 0x34, 0x2b, 0x34, 0x39, 0x29, 0x33, 
0x24, 0x34, 0x41, 0x29, 0x24, 0x40, 0x4b, 0x32, 
0x22, 0x48, 0x60, 0x0d, 0x0a, 0x60, 0x0d, 0x0a, 
0x65, 0x6e, 0x64, 0x0d, 0x0a);



n=smtp_send_socket(socket:s, from: fromaddr, to: toaddr, body: string(header,msg));
n_sent=n_sent+n;

# Alternative MIME attachment



header = string("From: ", fromaddr, "\r\nTo: ", toaddr, "\r\n",
	"Organization: Nessus kabale\r\nMIME-Version: 1.0\r\n");
	
msg = raw_string(0x53, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x3a, 
0x20, 0x4e, 0x65, 0x73, 0x73, 0x75, 0x73, 0x20, 
0x61, 0x6e, 0x74, 0x69, 0x76, 0x69, 0x72, 0x75, 
0x73, 0x20, 0x74, 0x65, 0x73, 0x74, 0x20, 0x33, 
0x3a, 0x20, 0x61, 0x6c, 0x74, 0x65, 0x72, 0x6e, 
0x61, 0x74, 0x69, 0x76, 0x65, 0x20, 0x62, 0x61, 
0x73, 0x65, 0x36, 0x34, 0x20, 0x61, 0x74, 0x74, 
0x61, 0x63, 0x68, 0x6d, 0x65, 0x6e, 0x74, 0x0d, 
0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x74, 
0x2d, 0x54, 0x79, 0x70, 0x65, 0x3a, 0x20, 0x6d, 
0x75, 0x6c, 0x74, 0x69, 0x70, 0x61, 0x72, 0x74, 
0x2f, 0x6d, 0x69, 0x78, 0x65, 0x64, 0x3b, 0x20, 
0x62, 0x6f, 0x75, 0x6e, 0x64, 0x61, 0x72, 0x79, 
0x3d, 0x22, 0x3d, 0x2d, 0x3d, 0x2d, 0x3d, 0x22, 
0x0d, 0x0a, 0x4c, 0x69, 0x6e, 0x65, 0x73, 0x3a, 
0x20, 0x31, 0x33, 0x0d, 0x0a, 0x0d, 0x0a, 0x0d, 
0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 0x3d, 
0x0d, 0x0a, 0x0d, 0x0a, 0x49, 0x66, 0x20, 0x79, 
0x6f, 0x75, 0x20, 0x63, 0x61, 0x6e, 0x20, 0x72, 
0x65, 0x61, 0x64, 0x20, 0x6f, 0x72, 0x20, 0x65, 
0x78, 0x65, 0x63, 0x75, 0x74, 0x65, 0x20, 0x74, 
0x68, 0x65, 0x20, 0x61, 0x74, 0x74, 0x61, 0x63, 
0x68, 0x6d, 0x65, 0x6e, 0x74, 0x2c, 0x20, 0x74, 
0x68, 0x69, 0x73, 0x20, 0x6d, 0x65, 0x61, 0x6e, 
0x73, 0x20, 0x74, 0x68, 0x61, 0x74, 0x20, 0x79, 
0x6f, 0x75, 0x20, 0x64, 0x6f, 0x20, 0x6e, 0x6f, 
0x74, 0x0d, 0x0a, 0x68, 0x61, 0x76, 0x65, 0x20, 
0x61, 0x6e, 0x20, 0x61, 0x6e, 0x74, 0x69, 0x76, 
0x69, 0x72, 0x75, 0x73, 0x2c, 0x20, 0x6f, 0x72, 
0x20, 0x74, 0x68, 0x61, 0x74, 0x20, 0x69, 0x74, 
0x20, 0x77, 0x61, 0x73, 0x20, 0x64, 0x69, 0x73, 
0x61, 0x62, 0x6c, 0x65, 0x64, 0x2e, 0x0d, 0x0a, 
0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 
0x3d, 0x0d, 0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 
0x6e, 0x74, 0x2d, 0x54, 0x79, 0x70, 0x65, 0x3a, 
0x20, 0x61, 0x70, 0x70, 0x6c, 0x69, 0x63, 0x61, 
0x74, 0x69, 0x6f, 0x6e, 0x2f, 0x6f, 0x63, 0x74, 
0x65, 0x74, 0x2d, 0x73, 0x74, 0x72, 0x65, 0x61, 
0x6d, 0x0d, 0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 
0x6e, 0x74, 0x2d, 0x44, 0x69, 0x73, 0x70, 0x6f, 
0x73, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x3a, 0x20, 
0x61, 0x74, 0x74, 0x61, 0x63, 0x68, 0x6d, 0x65, 
0x6e, 0x74, 0x3b, 0x20, 0x66, 0x69, 0x6c, 0x65, 
0x6e, 0x61, 0x6d, 0x65, 0x2a, 0x31, 0x3d, 0x22, 
0x65, 0x69, 0x63, 0x61, 0x72, 0x2e, 0x22, 0x3b, 
0x20, 0x66, 0x69, 0x6c, 0x65, 0x6e, 0x61, 0x6d, 
0x65, 0x2a, 0x32, 0x3d, 0x22, 0x63, 0x6f, 0x6d, 
0x22, 0x0d, 0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 
0x6e, 0x74, 0x2d, 0x44, 0x65, 0x73, 0x63, 0x72, 
0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x3a, 0x20, 
0x45, 0x49, 0x43, 0x41, 0x52, 0x20, 0x74, 0x65, 
0x73, 0x74, 0x20, 0x66, 0x69, 0x6c, 0x65, 0x0d, 
0x0a, 0x0d, 0x0a, 0x58, 0x35, 0x4f, 0x21, 0x50, 
0x25, 0x40, 0x41, 0x50, 0x5b, 0x34, 0x5c, 0x50, 
0x5a, 0x58, 0x35, 0x34, 0x28, 0x50, 0x5e, 0x29, 
0x37, 0x43, 0x43, 0x29, 0x37, 0x7d, 0x24, 0x45, 
0x49, 0x43, 0x41, 0x52, 0x2d, 0x53, 0x54, 0x41, 
0x4e, 0x44, 0x41, 0x52, 0x44, 0x2d, 0x41, 0x4e, 
0x54, 0x49, 0x56, 0x49, 0x52, 0x55, 0x53, 0x2d, 
0x54, 0x45, 0x53, 0x54, 0x2d, 0x46, 0x49, 0x4c, 
0x45, 0x21, 0x24, 0x48, 0x2b, 0x48, 0x2a, 0x0d, 
0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 0x3d, 
0x2d, 0x2d, 0x0d, 0x0a, 0x0d, 0x0a);



n=smtp_send_socket(socket:s, from: fromaddr, to: toaddr, body: header+msg);
n_sent=n_sent+n;

# Broken MIME attachment (ISO encoding)

header = string("From: ", fromaddr, "\r\nTo: ", toaddr, "\r\n",
	"Organization: Nessus kabale\r\nMIME-Version: 1.0\r\n");
	

msg = raw_string(
0x53, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x3a, 
0x20, 0x4e, 0x65, 0x73, 0x73, 0x75, 0x73, 0x20, 
0x61, 0x6e, 0x74, 0x69, 0x76, 0x69, 0x72, 0x75, 
0x73, 0x20, 0x74, 0x65, 0x73, 0x74, 0x20, 0x34, 
0x3a, 0x20, 0x62, 0x72, 0x6f, 0x6b, 0x65, 0x6e, 
0x20, 0x4d, 0x49, 0x4d, 0x45, 0x20, 0x61, 0x74, 
0x74, 0x61, 0x63, 0x68, 0x6d, 0x65, 0x6e, 0x74, 
0x20, 0x28, 0x49, 0x53, 0x4f, 0x20, 0x65, 0x6e, 
0x63, 0x6f, 0x64, 0x69, 0x6e, 0x67, 0x29, 0x0d, 
0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 0x74, 
0x2d, 0x54, 0x79, 0x70, 0x65, 0x3a, 0x20, 0x6d, 
0x75, 0x6c, 0x74, 0x69, 0x70, 0x61, 0x72, 0x74, 
0x2f, 0x6d, 0x69, 0x78, 0x65, 0x64, 0x3b, 0x20, 
0x62, 0x6f, 0x75, 0x6e, 0x64, 0x61, 0x72, 0x79, 
0x3d, 0x22, 0x3d, 0x2d, 0x3d, 0x2d, 0x3d, 0x22, 
0x0d, 0x0a, 0x4c, 0x69, 0x6e, 0x65, 0x73, 0x3a, 
0x20, 0x31, 0x33, 0x0d, 0x0a, 0x0d, 0x0a, 0x0d, 
0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 0x3d, 
0x0d, 0x0a, 0x0d, 0x0a, 0x49, 0x66, 0x20, 0x79, 
0x6f, 0x75, 0x20, 0x63, 0x61, 0x6e, 0x20, 0x72, 
0x65, 0x61, 0x64, 0x20, 0x6f, 0x72, 0x20, 0x65, 
0x78, 0x65, 0x63, 0x75, 0x74, 0x65, 0x20, 0x74, 
0x68, 0x65, 0x20, 0x61, 0x74, 0x74, 0x61, 0x63, 
0x68, 0x6d, 0x65, 0x6e, 0x74, 0x2c, 0x20, 0x74, 
0x68, 0x69, 0x73, 0x20, 0x6d, 0x65, 0x61, 0x6e, 
0x73, 0x20, 0x74, 0x68, 0x61, 0x74, 0x20, 0x79, 
0x6f, 0x75, 0x20, 0x64, 0x6f, 0x20, 0x6e, 0x6f, 
0x74, 0x0d, 0x0a, 0x68, 0x61, 0x76, 0x65, 0x20, 
0x61, 0x6e, 0x20, 0x61, 0x6e, 0x74, 0x69, 0x76, 
0x69, 0x72, 0x75, 0x73, 0x2c, 0x20, 0x6f, 0x72, 
0x20, 0x74, 0x68, 0x61, 0x74, 0x20, 0x69, 0x74, 
0x20, 0x77, 0x61, 0x73, 0x20, 0x64, 0x69, 0x73, 
0x61, 0x62, 0x6c, 0x65, 0x64, 0x2e, 0x0d, 0x0a, 
0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 
0x3d, 0x0d, 0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 
0x6e, 0x74, 0x2d, 0x54, 0x79, 0x70, 0x65, 0x3a, 
0x20, 0x61, 0x70, 0x70, 0x6c, 0x69, 0x63, 0x61, 
0x74, 0x69, 0x6f, 0x6e, 0x2f, 0x6f, 0x63, 0x74, 
0x65, 0x74, 0x2d, 0x73, 0x74, 0x72, 0x65, 0x61, 
0x6d, 0x0d, 0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 
0x6e, 0x74, 0x2d, 0x44, 0x69, 0x73, 0x70, 0x6f, 
0x73, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x3a, 0x20, 
0x61, 0x74, 0x74, 0x61, 0x63, 0x68, 0x6d, 0x65, 
0x6e, 0x74, 0x3b, 0x20, 0x66, 0x69, 0x6c, 0x65, 
0x6e, 0x61, 0x6d, 0x65, 0x3d, 0x65, 0x69, 0x63, 
0x61, 0x72, 0x2e, 0x3d, 0x3f, 0x49, 0x53, 0x4f, 
0x2d, 0x38, 0x38, 0x35, 0x39, 0x2d, 0x31, 0x3f, 
0x51, 0x3f, 0x63, 0x3f, 0x3d, 0x20, 0x3d, 0x3f, 
0x49, 0x53, 0x4f, 0x2d, 0x38, 0x38, 0x35, 0x39, 
0x2d, 0x31, 0x3f, 0x51, 0x3f, 0x6f, 0x3f, 0x3d, 
0x20, 0x3d, 0x3f, 0x49, 0x53, 0x4f, 0x2d, 0x38, 
0x38, 0x35, 0x39, 0x2d, 0x31, 0x3f, 0x51, 0x3f, 
0x6d, 0x3f, 0x3d, 0x20, 0x0d, 0x0a, 0x43, 0x6f, 
0x6e, 0x74, 0x65, 0x6e, 0x74, 0x2d, 0x44, 0x65, 
0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 
0x6e, 0x3a, 0x20, 0x45, 0x49, 0x43, 0x41, 0x52, 
0x20, 0x74, 0x65, 0x73, 0x74, 0x20, 0x66, 0x69, 
0x6c, 0x65, 0x0d, 0x0a, 0x0d, 0x0a, 0x58, 0x35, 
0x4f, 0x21, 0x50, 0x25, 0x40, 0x41, 0x50, 0x5b, 
0x34, 0x5c, 0x50, 0x5a, 0x58, 0x35, 0x34, 0x28, 
0x50, 0x5e, 0x29, 0x37, 0x43, 0x43, 0x29, 0x37, 
0x7d, 0x24, 0x45, 0x49, 0x43, 0x41, 0x52, 0x2d, 
0x53, 0x54, 0x41, 0x4e, 0x44, 0x41, 0x52, 0x44, 
0x2d, 0x41, 0x4e, 0x54, 0x49, 0x56, 0x49, 0x52, 
0x55, 0x53, 0x2d, 0x54, 0x45, 0x53, 0x54, 0x2d, 
0x46, 0x49, 0x4c, 0x45, 0x21, 0x24, 0x48, 0x2b, 
0x48, 0x2a, 0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 
0x3d, 0x2d, 0x3d, 0x2d, 0x2d, 0x0d, 0x0a, 0x0d, 
0x0a);


n=smtp_send_socket(socket:s, from: fromaddr, to: toaddr, body: string(header,msg));
n_sent=n_sent+n;

# Case sensitivity of Content-Type and Content-Disposition

header = string("From: ", fromaddr, "\r\nTo: ", toaddr, "\r\n",
	"Organization: Nessus kabale\r\nMIME-Version: 1.0\r\n");


msg = raw_string(
0x53, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x3a, 
0x20, 0x4e, 0x65, 0x73, 0x73, 0x75, 0x73, 0x20, 
0x61, 0x6e, 0x74, 0x69, 0x76, 0x69, 0x72, 0x75, 
0x73, 0x20, 0x74, 0x65, 0x73, 0x74, 0x20, 0x35, 
0x3a, 0x20, 0x27, 0x6d, 0x69, 0x78, 0x65, 0x64, 
0x20, 0x63, 0x61, 0x73, 0x65, 0x27, 0x20, 0x62, 
0x61, 0x73, 0x65, 0x36, 0x34, 0x20, 0x61, 0x74, 
0x74, 0x61, 0x63, 0x68, 0x6d, 0x65, 0x6e, 0x74, 
0x0d, 0x0a, 0x43, 0x6f, 0x6e, 0x74, 0x65, 0x6e, 
0x74, 0x2d, 0x54, 0x79, 0x70, 0x65, 0x3a, 0x20, 
0x6d, 0x75, 0x6c, 0x74, 0x69, 0x70, 0x61, 0x72, 
0x74, 0x2f, 0x6d, 0x69, 0x78, 0x65, 0x64, 0x3b, 
0x20, 0x62, 0x6f, 0x75, 0x6e, 0x64, 0x61, 0x72, 
0x79, 0x3d, 0x22, 0x3d, 0x2d, 0x3d, 0x2d, 0x3d, 
0x22, 0x0d, 0x0a, 0x4c, 0x69, 0x6e, 0x65, 0x73, 
0x3a, 0x20, 0x31, 0x32, 0x0d, 0x0a, 0x0d, 0x0a, 
0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 
0x3d, 0x0d, 0x0a, 0x0d, 0x0a, 0x49, 0x66, 0x20, 
0x79, 0x6f, 0x75, 0x20, 0x63, 0x61, 0x6e, 0x20, 
0x72, 0x65, 0x61, 0x64, 0x20, 0x6f, 0x72, 0x20, 
0x65, 0x78, 0x65, 0x63, 0x75, 0x74, 0x65, 0x20, 
0x74, 0x68, 0x65, 0x20, 0x61, 0x74, 0x74, 0x61, 
0x63, 0x68, 0x6d, 0x65, 0x6e, 0x74, 0x2c, 0x20, 
0x74, 0x68, 0x69, 0x73, 0x20, 0x6d, 0x65, 0x61, 
0x6e, 0x73, 0x20, 0x74, 0x68, 0x61, 0x74, 0x20, 
0x79, 0x6f, 0x75, 0x20, 0x64, 0x6f, 0x20, 0x6e, 
0x6f, 0x74, 0x0d, 0x0a, 0x68, 0x61, 0x76, 0x65, 
0x20, 0x61, 0x6e, 0x20, 0x61, 0x6e, 0x74, 0x69, 
0x76, 0x69, 0x72, 0x75, 0x73, 0x2c, 0x20, 0x6f, 
0x72, 0x20, 0x74, 0x68, 0x61, 0x74, 0x20, 0x69, 
0x74, 0x20, 0x77, 0x61, 0x73, 0x20, 0x64, 0x69, 
0x73, 0x61, 0x62, 0x6c, 0x65, 0x64, 0x2e, 0x0d, 
0x0a, 0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 
0x2d, 0x3d, 0x0d, 0x0a, 0x43, 0x4f, 0x4e, 0x54, 
0x45, 0x4e, 0x54, 0x2d, 0x74, 0x79, 0x70, 0x65, 
0x3a, 0x20, 0x74, 0x65, 0x78, 0x74, 0x2f, 0x70, 
0x6c, 0x61, 0x69, 0x6e, 0x3b, 0x0d, 0x0a, 0x09, 
0x4e, 0x41, 0x6d, 0x65, 0x3d, 0x22, 0x65, 0x69, 
0x63, 0x61, 0x72, 0x2e, 0x63, 0x6f, 0x6d, 0x22, 
0x0d, 0x0a, 0x0d, 0x0a, 0x58, 0x35, 0x4f, 0x21, 
0x50, 0x25, 0x40, 0x41, 0x50, 0x5b, 0x34, 0x5c, 
0x50, 0x5a, 0x58, 0x35, 0x34, 0x28, 0x50, 0x5e, 
0x29, 0x37, 0x43, 0x43, 0x29, 0x37, 0x7d, 0x24, 
0x45, 0x49, 0x43, 0x41, 0x52, 0x2d, 0x53, 0x54, 
0x41, 0x4e, 0x44, 0x41, 0x52, 0x44, 0x2d, 0x41, 
0x4e, 0x54, 0x49, 0x56, 0x49, 0x52, 0x55, 0x53, 
0x2d, 0x54, 0x45, 0x53, 0x54, 0x2d, 0x46, 0x49, 
0x4c, 0x45, 0x21, 0x24, 0x48, 0x2b, 0x48, 0x2a, 
0x0d, 0x0a, 0x2d, 0x2d, 0x3d, 0x2d, 0x3d, 0x2d, 
0x3d, 0x2d, 0x2d, 0x0d, 0x0a, 0x0d, 0x0a);


n=smtp_send_socket(socket:s, from: fromaddr, to: toaddr, body: string(header,msg));
n_sent=n_sent+n;


# TBD: broken MIME attachment - Cf. Bugtraq archives

# Close & quit

send(socket: s, data: string("QUIT\r\n"));
close(s);
if (n_sent == 0) {
  security_note(port: port, 
	data: "For some reason, we could not send the EICAR test string to this MTA");
} 
if (n_sent > 0) {
  security_note(port);
}

